/*****************************************************************
*
*     Project:      Firefly X10 Board
*
*     File:         x10types.h
*
*     Version:      1.0
*
*     Description:  Type definitions
*
*     Changes:
*     1.0 MJB       First version, 28/2/2003
*
*****************************************************************/

#ifndef X10TYPES_H
#define X10TYPES_H

#ifndef TRUE
#define TRUE                      true
#endif
#ifndef FALSE
#define FALSE                     false
#endif

#ifndef min
#define min(a, b)                 ((a) < (b) ? (a) : (b))
#endif
#ifndef max
#define max(a, b)                 ((a) > (b) ? (a) : (b))
#endif

typedef unsigned long             DWORD;
typedef unsigned long *           LPDWORD;
typedef unsigned int              WORD;
typedef unsigned int *            LPWORD;
typedef unsigned int              UINT;
typedef unsigned char             BYTE;
typedef unsigned char *           LPBYTE;
typedef struct usb_dev_handle *   HANDLE;
typedef bool                      BOOL;
typedef bool *                    LPBOOL;

#define BIT0                      0x0001
#define BIT1                      0x0002
#define BIT2                      0x0004
#define BIT3                      0x0008
#define BIT4                      0x0010
#define BIT5                      0x0020
#define BIT6                      0x0040
#define BIT7                      0x0080
#define BIT8                      0x0100
#define BIT9                      0x0200
#define BIT10                     0x0400
#define BIT11                     0x0800
#define BIT12                     0x1000
#define BIT13                     0x2000
#define BIT14                     0x4000
#define BIT15                     0x8000

typedef struct _DCB {
    DWORD BaudRate;
    DWORD fParity: 1;
    DWORD fOutxCtsFlow: 1;
    DWORD fRtsControl: 2;
    BYTE Parity;
} DCB, *LPDCB;

#endif
